package com.synnex.plugin;

import org.apache.cordova.api.Plugin;
import org.apache.cordova.api.PluginResult;
import org.json.JSONArray;

import android.app.Activity;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;

import com.synnex.phonegap.BarcodeActivity;

public class BarcodePlugin extends Plugin
{
	private final int CODE_REQ_BARCODE = 1;
	
	private final int WHAT_BARCODE_SCAN = 1;
	
	private String text;
	
	private Object synObj = new Object();
	
	private Handler handler = new Handler()
	{
		public void handleMessage(Message msg)
		{
			if(msg == null)
			{
				return;
			}
			switch (msg.what)
			{
				case WHAT_BARCODE_SCAN:
					Intent intent = new Intent(ctx.getContext(), BarcodeActivity.class);
					ctx.startActivityForResult(BarcodePlugin.this, intent, CODE_REQ_BARCODE);
					break;
			}
		};
	};
	
	public PluginResult execute(String action, JSONArray args, String callbackId)
	{
		text = "";
		handler.sendEmptyMessage(WHAT_BARCODE_SCAN);
		
		sleep();

		return new PluginResult(PluginResult.Status.OK, text);
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent)
	{
		if(requestCode == CODE_REQ_BARCODE)
		{
			if(resultCode == Activity.RESULT_OK)
			{
				text = intent.getExtras().getString("text");
			}
			weakup();
		}
		else
		{
			super.onActivityResult(requestCode, resultCode, intent);
		}
	}
	
	private void sleep()
	{
		try
		{
			synchronized(synObj)
			{
				synObj.wait();
			}
		}
		catch (InterruptedException e)
		{
			e.printStackTrace();
		}
	}
	
	private void weakup()
	{
		synchronized(synObj)
		{
			synObj.notify();
		}
	}
}