package com.synnex.plugin;

import org.apache.cordova.api.PluginResult;
import org.json.JSONArray;
import org.json.JSONObject;

import android.os.Handler;
import android.os.Message;
import android.widget.Toast;

import com.phonegap.api.Plugin;

public class LoginPlugin extends Plugin
{
	private final String ACTION_LOGIN = "login";
	private final int WHAT_USER_LOGIN = 1;
	
	private Handler handler = new Handler()
	{
		public void handleMessage(Message msg)
		{
			if(msg == null)
			{
				return;
			}
			switch (msg.what)
			{
				case WHAT_USER_LOGIN:
					String info = (String)msg.obj;
					Toast.makeText(ctx.getContext(), info, Toast.LENGTH_SHORT).show();
					break;
			}
		};
	};
	
	/**
	 * NOTE:
	 * if isSynch() return true, this method called in main thread(UI thread);
	 * otherwise, this method called in small thread(Not UI thread)
	 */
	public PluginResult execute(String action, JSONArray args, String callbackId)
	{
		System.out.println("## LoginPlugin ##" + action);
		System.out.println(args);
		try
		{
			JSONObject obj = args.getJSONObject(0);
			String username = obj.getString("username");
			String password = obj.getString("password");
			
			notifyUI(username, password);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		return new PluginResult(PluginResult.Status.OK, "登陆成功!");
	}
	
	
	
//	public boolean isSynch(String action)
//	{
//		return ACTION_LOGIN.equals(action);
//	}

	private void notifyUI(String username, String password)
	{
		Message msg = handler.obtainMessage();
		msg.what = WHAT_USER_LOGIN;
		msg.obj = "username: " + username + ", password: " + password;
		handler.sendMessage(msg);
	}
}
